"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.plugin = void 0;
const schema_ast_1 = require("@graphql-codegen/schema-ast");
const index_1 = require("./yup/index");
const plugin_helpers_1 = require("@graphql-codegen/plugin-helpers");
const plugin = (schema, _documents, config) => __awaiter(void 0, void 0, void 0, function* () {
    const { schema: _schema, ast } = (0, schema_ast_1.transformSchemaAST)(schema, config);
    const _a = (0, index_1.YupSchemaVisitor)(_schema, config), { buildImports } = _a, visitor = __rest(_a, ["buildImports"]);
    const result = (0, plugin_helpers_1.oldVisit)(ast, {
        leave: visitor
    });
    // @ts-ignore
    const generated = result.definitions.filter((def) => typeof def === "string");
    return {
        prepend: buildImports(),
        content: "\n" + [...generated].join("\n"),
    };
});
exports.plugin = plugin;
